type Middleware<T> = (state: T, updater: (state: T) => void, next: (updater: (state: T) => void) => void) => void;
interface StateSlice<T> {
    get: () => T;
    set: (updater: (state: T) => void, actionType?: string) => void;
    use: () => [T, (updater: (state: T) => void, actionType?: string) => void];
    select: <R>(selector: (state: T) => R) => R;
}
export declare function createState<T extends Record<string, any>>(// 🔥 Enforce T as an object
name: string, initialState: T, middlewares?: Middleware<T>[], registerToGlobalStore?: boolean): StateSlice<T> & {
    select: <R>(selector: (state: T) => R) => R;
};
export declare function createAsyncAction<T, R>(asyncFn: (payload?: T) => Promise<R>, { onPending, onFulfilled, onRejected, }: {
    onPending?: (state: any) => void;
    onFulfilled?: (state: any, payload: R) => void;
    onRejected?: (state: any, error: any) => void;
}): (set: (updater: (state: any) => void) => void, payload?: T) => Promise<void>;
type AsyncHandlers<T> = {
    [key: string]: (payload?: any) => Promise<void>;
};
export declare function createSliceState<T extends Record<string, any>>({ name, initialState, actions, asyncActions, middlewares, registerToGlobalStore, globalUpdate, }: {
    name: string;
    initialState: T;
    actions?: Record<string, (state: T, payload?: any) => void>;
    asyncActions?: (actionMap: any) => void;
    middlewares?: Middleware<T>[];
    registerToGlobalStore?: boolean;
    globalUpdate?: boolean;
}): {
    get: () => any;
    set: (updater: (state: T) => void, actionType?: string) => void;
    use: () => [T, (updater: (state: T) => void, actionType?: string) => void];
    select: <R>(selector: (state: T) => R) => R;
    actions: Record<string, Function>;
    asyncActions: AsyncHandlers<T>;
};
export {};
