export type Middleware<T> = (state: T, updater: (state: T) => void, next: (updater: (state: T) => void) => void) => void;
export type StateSetter<T> = (updater: (state: T) => void) => void;
export interface StateSlice<T extends Record<string, any>> {
    get: () => T;
    set: StateSetter<T>;
    use: () => [T, StateSetter<T>];
}
